SDL_thread.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_properties.h>`
`#include <SDL3/SDL_atomic.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_thread.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_BeginThreadFunction NULL
#define | SDL_EndThreadFunction NULL
#define | SDL_CreateThread(fn, name, data) SDL_CreateThreadRuntime((fn), (name), (data), (SDL_FunctionPointer) (SDL_BeginThreadFunction), (SDL_FunctionPointer) (SDL_EndThreadFunction))
#define | SDL_CreateThreadWithProperties(props) SDL_CreateThreadWithPropertiesRuntime((props), (SDL_FunctionPointer) (SDL_BeginThreadFunction), (SDL_FunctionPointer) (SDL_EndThreadFunction))
#define | SDL_PROP_THREAD_CREATE_ENTRY_FUNCTION_POINTER "SDL.thread.create.entry_function"
#define | SDL_PROP_THREAD_CREATE_NAME_STRING "SDL.thread.create.name"
#define | SDL_PROP_THREAD_CREATE_USERDATA_POINTER "SDL.thread.create.userdata"
#define | SDL_PROP_THREAD_CREATE_STACKSIZE_NUMBER "SDL.thread.create.stacksize"

## Typedefs

typedef struct SDL_Thread | SDL_Thread
typedef Uint64 | SDL_ThreadID
typedef SDL_AtomicInt | SDL_TLSID
typedef int(* | SDL_ThreadFunction) (void *data)
typedef void(* | SDL_TLSDestructorCallback) (void *value)

## Enumerations

enum | SDL_ThreadPriority { SDL_THREAD_PRIORITY_LOW , SDL_THREAD_PRIORITY_NORMAL , SDL_THREAD_PRIORITY_HIGH , SDL_THREAD_PRIORITY_TIME_CRITICAL }
enum | SDL_ThreadState { SDL_THREAD_UNKNOWN , SDL_THREAD_ALIVE , SDL_THREAD_DETACHED , SDL_THREAD_COMPLETE }

## Functions

SDL_Thread * | SDL_CreateThreadRuntime (SDL_ThreadFunction fn, const char *name, void *data, SDL_FunctionPointer pfnBeginThread, SDL_FunctionPointer pfnEndThread)
SDL_Thread * | SDL_CreateThreadWithPropertiesRuntime (SDL_PropertiesID props, SDL_FunctionPointer pfnBeginThread, SDL_FunctionPointer pfnEndThread)
const char * | SDL_GetThreadName (SDL_Thread *thread)
SDL_ThreadID | SDL_GetCurrentThreadID (void)
SDL_ThreadID | SDL_GetThreadID (SDL_Thread *thread)
bool | SDL_SetCurrentThreadPriority (SDL_ThreadPriority priority)
void | SDL_WaitThread (SDL_Thread *thread, int *status)
SDL_ThreadState | SDL_GetThreadState (SDL_Thread *thread)
void | SDL_DetachThread (SDL_Thread *thread)
void * | SDL_GetTLS (SDL_TLSID *id)
bool | SDL_SetTLS (SDL_TLSID *id, const void *value, SDL_TLSDestructorCallback destructor)
void | SDL_CleanupTLS (void)

## Macro Definition Documentation

## SDL_BeginThreadFunction

#define SDL_BeginThreadFunction NULL

Definition at line 307 of file SDL_thread.h.

## SDL_CreateThread

#define SDL_CreateThread | ( |  | fn,
|  |  | name,
|  |  | data
| ) |  | SDL_CreateThreadRuntime((fn), (name), (data), (SDL_FunctionPointer) (SDL_BeginThreadFunction), (SDL_FunctionPointer) (SDL_EndThreadFunction))

Definition at line 349 of file SDL_thread.h.

## SDL_CreateThreadWithProperties

#define SDL_CreateThreadWithProperties | ( |  | props | ) | SDL_CreateThreadWithPropertiesRuntime((props), (SDL_FunctionPointer) (SDL_BeginThreadFunction), (SDL_FunctionPointer) (SDL_EndThreadFunction))

Definition at line 350 of file SDL_thread.h.

## SDL_EndThreadFunction

#define SDL_EndThreadFunction NULL

Definition at line 313 of file SDL_thread.h.

## SDL_PROP_THREAD_CREATE_ENTRY_FUNCTION_POINTER

#define SDL_PROP_THREAD_CREATE_ENTRY_FUNCTION_POINTER "SDL.thread.create.entry_function"

Definition at line 351 of file SDL_thread.h.

## SDL_PROP_THREAD_CREATE_NAME_STRING

#define SDL_PROP_THREAD_CREATE_NAME_STRING "SDL.thread.create.name"

Definition at line 352 of file SDL_thread.h.

## SDL_PROP_THREAD_CREATE_STACKSIZE_NUMBER

#define SDL_PROP_THREAD_CREATE_STACKSIZE_NUMBER "SDL.thread.create.stacksize"

Definition at line 354 of file SDL_thread.h.

## SDL_PROP_THREAD_CREATE_USERDATA_POINTER

#define SDL_PROP_THREAD_CREATE_USERDATA_POINTER "SDL.thread.create.userdata"

Definition at line 353 of file SDL_thread.h.

## Typedef Documentation

## SDL_Thread

typedef struct SDL_Thread SDL_Thread

# CategoryThread

SDL offers cross-platform thread management functions. These are mostly concerned with starting threads, setting their priority, and dealing with their termination.

In addition, there is support for Thread Local Storage (data that is unique to each thread, but accessed from a single key).

On platforms without thread support (such as Emscripten when built without pthreads), these functions still exist, but things like SDL_CreateThread() will report failure without doing anything.

If you're going to work with threads, you almost certainly need to have a good understanding of [CategoryMutex](CategoryMutex) as well. The SDL thread object.

These are opaque data.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_CreateThread
  SDL_WaitThread

Definition at line 70 of file SDL_thread.h.

## SDL_ThreadFunction

typedef int(* SDL_ThreadFunction) (void *data)

The function passed to SDL_CreateThread() as the new thread's entry point.

Parameters

  data | what was passed as `data` to SDL_CreateThread().

Returns
  a value that can be reported through SDL_WaitThread().

Since
  This datatype is available since SDL 3.2.0.

Definition at line 142 of file SDL_thread.h.

## SDL_ThreadID

typedef Uint64 SDL_ThreadID

A unique numeric ID that identifies a thread.

These are different from SDL_Thread objects, which are generally what an application will operate on, but having a way to uniquely identify a thread can be useful at times.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_GetThreadID
  SDL_GetCurrentThreadID

Definition at line 84 of file SDL_thread.h.

## SDL_TLSDestructorCallback

typedef void(* SDL_TLSDestructorCallback) (void *value)

The callback used to cleanup data passed to SDL_SetTLS.

This is called when a thread exits, to allow an app to free any resources.

Parameters

  value | a pointer previously handed to SDL_SetTLS.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_SetTLS

Definition at line 529 of file SDL_thread.h.

## SDL_TLSID

typedef SDL_AtomicInt SDL_TLSID

Thread local storage ID.

0 is the invalid ID. An app can create these and then set data for these IDs that is unique to each thread.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_GetTLS
  SDL_SetTLS

Definition at line 97 of file SDL_thread.h.

## Enumeration Type Documentation

## SDL_ThreadPriority

enum SDL_ThreadPriority

The SDL thread priority.

SDL will make system changes as necessary in order to apply the thread priority. Code which attempts to control thread state related to priority should be aware that calling SDL_SetCurrentThreadPriority may alter such state. SDL_HINT_THREAD_PRIORITY_POLICY can be used to control aspects of this behavior.

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_THREAD_PRIORITY_LOW |
SDL_THREAD_PRIORITY_NORMAL |
SDL_THREAD_PRIORITY_HIGH |
SDL_THREAD_PRIORITY_TIME_CRITICAL |

Definition at line 110 of file SDL_thread.h.

{
SDL_THREAD_PRIORITY_LOW,
SDL_THREAD_PRIORITY_NORMAL,
SDL_THREAD_PRIORITY_HIGH,
SDL_THREAD_PRIORITY_TIME_CRITICAL
} SDL_ThreadPriority;
SDL_ThreadPriority
SDL_ThreadPriority
Definition SDL_thread.h:110
SDL_THREAD_PRIORITY_TIME_CRITICAL
@ SDL_THREAD_PRIORITY_TIME_CRITICAL
Definition SDL_thread.h:114
SDL_THREAD_PRIORITY_LOW
@ SDL_THREAD_PRIORITY_LOW
Definition SDL_thread.h:111
SDL_THREAD_PRIORITY_HIGH
@ SDL_THREAD_PRIORITY_HIGH
Definition SDL_thread.h:113
SDL_THREAD_PRIORITY_NORMAL
@ SDL_THREAD_PRIORITY_NORMAL
Definition SDL_thread.h:112

## SDL_ThreadState

enum SDL_ThreadState

The SDL thread state.

The current state of a thread can be checked by calling SDL_GetThreadState.

Since
  This enum is available since SDL 3.2.0.

See also
  SDL_GetThreadState

Enumerator
SDL_THREAD_UNKNOWN | The thread is not valid
SDL_THREAD_ALIVE | The thread is currently running
SDL_THREAD_DETACHED | The thread is detached and can't be waited on
SDL_THREAD_COMPLETE | The thread has finished and should be cleaned up with SDL_WaitThread()

Definition at line 126 of file SDL_thread.h.

{
SDL_THREAD_UNKNOWN, /**< The thread is not valid */
SDL_THREAD_ALIVE, /**< The thread is currently running */
SDL_THREAD_DETACHED, /**< The thread is detached and can't be waited on */
SDL_THREAD_COMPLETE /**< The thread has finished and should be cleaned up with SDL_WaitThread() */
} SDL_ThreadState;
SDL_ThreadState
SDL_ThreadState
Definition SDL_thread.h:127
SDL_THREAD_ALIVE
@ SDL_THREAD_ALIVE
Definition SDL_thread.h:129
SDL_THREAD_COMPLETE
@ SDL_THREAD_COMPLETE
Definition SDL_thread.h:131
SDL_THREAD_UNKNOWN
@ SDL_THREAD_UNKNOWN
Definition SDL_thread.h:128
SDL_THREAD_DETACHED
@ SDL_THREAD_DETACHED
Definition SDL_thread.h:130

## Function Documentation

## SDL_CleanupTLS()

void SDL_CleanupTLS | ( | void |  | ) |

extern

Cleanup all TLS data for this thread.

If you are creating your threads outside of SDL and then calling SDL functions, you should call this function before your thread exits, to properly clean up SDL memory.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_CreateThreadRuntime()

SDL_Thread * SDL_CreateThreadRuntime | ( | SDL_ThreadFunction | fn,
|  | const char * | name,
|  | void * | data,
|  | SDL_FunctionPointer | pfnBeginThread,
|  | SDL_FunctionPointer | pfnEndThread
| ) |  |

extern

The actual entry point for SDL_CreateThread.

Parameters

  fn | the SDL_ThreadFunction function to call in the new thread
  name | the name of the thread
  data | a pointer that is passed to `fn`
  pfnBeginThread | the C runtime's _beginthreadex (or whatnot). Can be NULL.
  pfnEndThread | the C runtime's _endthreadex (or whatnot). Can be NULL.

Returns
  an opaque pointer to the new thread object on success, NULL if the new thread could not be created; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_CreateThreadWithPropertiesRuntime()

SDL_Thread * SDL_CreateThreadWithPropertiesRuntime | ( | SDL_PropertiesID | props,
|  | SDL_FunctionPointer | pfnBeginThread,
|  | SDL_FunctionPointer | pfnEndThread
| ) |  |

extern

The actual entry point for SDL_CreateThreadWithProperties.

Parameters

  props | the properties to use
  pfnBeginThread | the C runtime's _beginthreadex (or whatnot). Can be NULL.
  pfnEndThread | the C runtime's _endthreadex (or whatnot). Can be NULL.

Returns
  an opaque pointer to the new thread object on success, NULL if the new thread could not be created; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_DetachThread()

void SDL_DetachThread | ( | SDL_Thread * | thread | ) |

extern

Let a thread clean up on exit without intervention.

A thread may be "detached" to signify that it should not remain until another thread has called SDL_WaitThread() on it. Detaching a thread is useful for long-running threads that nothing needs to synchronize with or further manage. When a detached thread is done, it simply goes away.

There is no way to recover the return code of a detached thread. If you need this, don't detach the thread and instead use SDL_WaitThread().

Once a thread is detached, you should usually assume the SDL_Thread isn't safe to reference again, as it will become invalid immediately upon the detached thread's exit, instead of remaining until someone has called SDL_WaitThread() to finally clean it up. As such, don't detach the same thread more than once.

If a thread has already exited when passed to SDL_DetachThread(), it will stop waiting for a call to SDL_WaitThread() and clean up immediately. It is not safe to detach a thread that might be used with SDL_WaitThread().

You may not call SDL_WaitThread() on a thread that has been detached. Use either that function or this one, but not both, or behavior is undefined.

It is safe to pass NULL to this function; it is a no-op.

Parameters

  thread | the SDL_Thread pointer that was returned from the SDL_CreateThread() call that started this thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateThread
  SDL_WaitThread

## SDL_GetCurrentThreadID()

SDL_ThreadID SDL_GetCurrentThreadID | ( | void |  | ) |

extern

Get the thread identifier for the current thread.

This thread identifier is as reported by the underlying operating system. If SDL is running on a platform that does not support threads the return value will always be zero.

This function also returns a valid thread ID when called from the main thread.

Returns
  the ID of the current thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetThreadID

## SDL_GetThreadID()

SDL_ThreadID SDL_GetThreadID | ( | SDL_Thread * | thread | ) |

extern

Get the thread identifier for the specified thread.

This thread identifier is as reported by the underlying operating system. If SDL is running on a platform that does not support threads the return value will always be zero.

Parameters

  thread | the thread to query.

Returns
  the ID of the specified thread, or the ID of the current thread if `thread` is NULL.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetCurrentThreadID

## SDL_GetThreadName()

const char * SDL_GetThreadName | ( | SDL_Thread * | thread | ) |

extern

Get the thread name as it was specified in SDL_CreateThread().

Parameters

  thread | the thread to query.

Returns
  a pointer to a UTF-8 string that names the specified thread, or NULL if it doesn't have a name.

Since
  This function is available since SDL 3.2.0.

## SDL_GetThreadState()

SDL_ThreadState SDL_GetThreadState | ( | SDL_Thread * | thread | ) |

extern

Get the current state of a thread.

Parameters

  thread | the thread to query.

Returns
  the current state of a thread, or SDL_THREAD_UNKNOWN if the thread isn't valid.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_ThreadState

## SDL_GetTLS()

void * SDL_GetTLS | ( | SDL_TLSID * | id | ) |

extern

Get the current thread's value associated with a thread local storage ID.

Parameters

  id | a pointer to the thread local storage ID, may not be NULL.

Returns
  the value associated with the ID for the current thread or NULL if no value has been set; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetTLS

## SDL_SetCurrentThreadPriority()

bool SDL_SetCurrentThreadPriority | ( | SDL_ThreadPriority | priority | ) |

extern

Set the priority for the current thread.

Note that some platforms will not let you alter the priority (or at least, promote the thread to a higher priority) at all, and some require you to be an administrator account. Be prepared for this to fail.

Parameters

  priority | the SDL_ThreadPriority to set.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_SetTLS()

bool SDL_SetTLS | ( | SDL_TLSID * | id,
|  | const void * | value,
|  | SDL_TLSDestructorCallback | destructor
| ) |  |

extern

Set the current thread's value associated with a thread local storage ID.

If the thread local storage ID is not initialized (the value is 0), a new ID will be created in a thread-safe way, so all calls using a pointer to the same ID will refer to the same local storage.

Note that replacing a value from a previous call to this function on the same thread does not call the previous value's destructor!

`destructor` can be NULL; it is assumed that `value` does not need to be cleaned up if so.

Parameters

  id | a pointer to the thread local storage ID, may not be NULL.
  value | the value to associate with the ID for the current thread.
  destructor | a function called when the thread exits, to free the value, may be NULL.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetTLS

## SDL_WaitThread()

void SDL_WaitThread | ( | SDL_Thread * | thread,
|  | int * | status
| ) |  |

extern

Wait for a thread to finish.

Threads that haven't been detached will remain until this function cleans them up. Not doing so is a resource leak.

Once a thread has been cleaned up through this function, the SDL_Thread that references it becomes invalid and should not be referenced again. As such, only one thread may call SDL_WaitThread() on another.

The return code from the thread function is placed in the area pointed to by `status`, if `status` is not NULL.

You may not wait on a thread that has been used in a call to SDL_DetachThread(). Use either that function or this one, but not both, or behavior is undefined.

It is safe to pass a NULL thread to this function; it is a no-op.

Note that the thread pointer is freed by this function and is not valid afterward.

Parameters

  thread | the SDL_Thread pointer that was returned from the SDL_CreateThread() call that started this thread.
  status | a pointer filled in with the value returned from the thread function by its 'return', or -1 if the thread has been detached or isn't valid, may be NULL.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CreateThread
  SDL_DetachThread